## ros-indigo-hrpsys-gazebo-general 0.1.12

=== CMakeLists.txt ===
# http://ros.org/doc/groovy/api/catkin/html/user_guide/supposed.html
cmake_minimum_required(VERSION 2.8.3)
project(hrpsys_gazebo_general)

find_package(catkin REQUIRED COMPONENTS hrpsys_ros_bridge hrpsys_gazebo_msgs)

find_package(PkgConfig)
pkg_check_modules(openrtm_aist openrtm-aist REQUIRED)
pkg_check_modules(openhrp3 openhrp3.1 REQUIRED)
find_package(collada_urdf_jsk_patch)
catkin_package(CATKIN_DEPENDS hrpsys_ros_bridge hrpsys_gazebo_msgs CFG_EXTRAS compile_robot_model_for_gazebo.cmake)

# set CMAKE_BUILD_TYPE
if(NOT CMAKE_BUILD_TYPE)
  set(
    CMAKE_BUILD_TYPE Release CACHE STRING
    "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
    FORCE)
endif()

## Build only gazebo iob
pkg_check_modules(omniorb omniORB4 REQUIRED)
pkg_check_modules(omnidynamic omniDynamic4 REQUIRED)
pkg_check_modules(openrtm_aist openrtm-aist REQUIRED)
pkg_check_modules(openhrp3 openhrp3.1 REQUIRED)
pkg_check_modules(hrpsys hrpsys-base REQUIRED)
### hotfix for https://github.com/fkanehiro/hrpsys-base/pull/803
list(GET hrpsys_INCLUDE_DIRS 0 hrpsys_first_incdir)
list(APPEND hrpsys_INCLUDE_DIRS ${hrpsys_first_incdir}/hrpsys)
list(APPEND hrpsys_INCLUDE_DIRS ${hrpsys_first_incdir}/hrpsys/idl)
if(EXISTS ${hrpsys_SOURCE_DIR})
  set(ROBOTHARDWARE_SOURCE ${hrpsys_SOURCE_DIR}/src/rtc/RobotHardware)
  set(HRPEC_SOURCE         ${hrpsys_SOURCE_DIR}/src/ec/hrpEC)
elseif(EXISTS ${hrpsys_SOURCE_PREFIX})
  set(ROBOTHARDWARE_SOURCE ${hrpsys_SOURCE_PREFIX}/src/rtc/RobotHardware)
  set(HRPEC_SOURCE         ${hrpsys_SOURCE_PREFIX}/src/ec/hrpEC)
else()
  set(ROBOTHARDWARE_SOURCE ${hrpsys_PREFIX}/share/hrpsys/src/rtc/RobotHardware)
  set(HRPEC_SOURCE         ${hrpsys_PREFIX}/share/hrpsys/src/ec/hrpEC)
endif()
include_directories(${catkin_INCLUDE_DIRS} ${openrtm_aist_INCLUDE_DIRS} ${openhrp3_INCLUDE_DIRS} ${hrpsys_INCLUDE_DIRS})
link_directories(${CATKIN_DEVEL_PREFIX}/lib ${hrpsys_PREFIX}/lib ${openhrp3_LIBRARY_DIRS} /opt/ros/$ENV{ROS_DISTRO}/lib/)
add_subdirectory(iob)

add_custom_target(hrpsys_gazebo_general_iob ALL DEPENDS RobotHardware_gazebo)
add_dependencies(hrpsys_gazebo_general_iob hrpsys_gazebo_msgs_gencpp)

## Gazebo plugins
include (FindPkgConfig)
if (PKG_CONFIG_FOUND)
  pkg_check_modules(GAZEBO gazebo)
else()
  message(FATAL_ERROR "pkg-config is required; please install it")
endif()

include_directories( ${GAZEBO_INCLUDE_DIRS} ${catkin_INCLUDE_DIRS} ${openrtm_aist_INCLUDE_DIRS} ${openhrp3_INCLUDE_DIRS})
link_directories( ${GAZEBO_LIBRARY_DIRS} ${openhrp3_LIBRARY_DIRS})

set(LIBRARY_OUTPUT_PATH ${PROJECT_SOURCE_DIR}/plugins)

add_library(IOBPlugin src/IOBPlugin.cpp)
add_dependencies(IOBPlugin hrpsys_gazebo_msgs_gencpp)
install(TARGETS IOBPlugin LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION})
add_library(SetVelPlugin src/SetVelPlugin.cpp)
add_dependencies(SetVelPlugin hrpsys_gazebo_msgs_gencpp)
install(TARGETS SetVelPlugin LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION})
add_library(AddForcePlugin src/AddForcePlugin.cpp)
add_dependencies(AddForcePlugin hrpsys_gazebo_msgs_gencpp)
install(TARGETS AddForcePlugin LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION})
add_library(GetVelPlugin src/GetVelPlugin.cpp)
add_dependencies(GetVelPlugin hrpsys_gazebo_msgs_gencpp)
install(TARGETS GetVelPlugin LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION})
add_library(PubTfPlugin src/PubTfPlugin.cpp)
add_dependencies(PubTfPlugin hrpsys_gazebo_msgs_gencpp)
install(TARGETS PubTfPlugin LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION})
add_library(ThermoPlugin src/ThermoPlugin.cpp)
add_dependencies(ThermoPlugin hrpsys_gazebo_msgs_gencpp)
install(TARGETS ThermoPlugin LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION})
add_library(LIPPlugin src/LIPPlugin.cpp)
add_dependencies(LIPPlugin hrpsys_gazebo_msgs_gencpp)
install(TARGETS LIPPlugin LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION})

## Convert robot models
include(${PROJECT_SOURCE_DIR}/cmake/compile_robot_model_for_gazebo.cmake)
if(EXISTS ${hrpsys_ros_bridge_SOURCE_DIR})
  set(hrpsys_ros_bridge_PACKAGE_PATH ${hrpsys_ros_bridge_SOURCE_DIR})
elseif(EXISTS ${hrpsys_ros_bridge_SOURCE_PREFIX})
  set(hrpsys_ros_bridge_PACKAGE_PATH ${hrpsys_ros_bridge_SOURCE_PREFIX})
else()
  set(hrpsys_ros_bridge_PACKAGE_PATH ${hrpsys_ros_bridge_PREFIX}/share/hrpsys_ros_bridge)
endif()
generate_gazebo_urdf_file(${hrpsys_ros_bridge_PACKAGE_PATH}/models/SampleRobot.dae)
add_custom_target(all_robots_compile ALL DEPENDS ${compile_urdf_robots})

## install
install(DIRECTORY launch scripts worlds config robot_models DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION} USE_SOURCE_PERMISSIONS)
install(PROGRAMS setup.sh DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION})

=== iob/CMakeLists.txt ===
add_definitions(-DHRPSYS_PACKAGE_VERSION=\"\\"${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}\\"\")

# hrpIo
add_library(hrpIo_gazebo SHARED iob.cpp)
add_dependencies(hrpIo_gazebo hrpsys_gazebo_msgs_gencpp)

if (NOT APPLE AND NOT QNXNTO)
   target_link_libraries(hrpIo_gazebo rt)
endif()

target_link_libraries(hrpIo_gazebo roscpp rostime)

# RobotHardware
set(comp_source  ${ROBOTHARDWARE_SOURCE}/robot.cpp ${ROBOTHARDWARE_SOURCE}/RobotHardware.cpp ${ROBOTHARDWARE_SOURCE}/RobotHardwareService_impl.cpp)
set(libs hrpIo_gazebo hrpModel-3.1 hrpCollision-3.1 hrpUtil-3.1 hrpsysBaseStub)

add_library(RobotHardware_gazebo SHARED ${comp_source})

target_link_libraries(RobotHardware_gazebo  ${libs})
set_target_properties(RobotHardware_gazebo PROPERTIES PREFIX "")
set_target_properties(RobotHardware_gazebo PROPERTIES LIBRARY_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR}/lib)
set_target_properties(RobotHardware_gazebo PROPERTIES OUTPUT_NAME RobotHardware)

add_executable(RobotHardwareComp_gazebo ${ROBOTHARDWARE_SOURCE}/RobotHardwareComp.cpp ${comp_source})
target_link_libraries(RobotHardwareComp_gazebo ${libs} ${omniorb_LIBRARIES} ${omnidynamic_LIBRARIES} RTC coil dl pthread)
set_target_properties(RobotHardwareComp_gazebo PROPERTIES OUTPUT_NAME RobotHardwareComp)

add_library(hrpEC_gazebo SHARED ${HRPEC_SOURCE}/hrpEC.cpp ${HRPEC_SOURCE}/hrpEC-common.cpp)
target_link_libraries(hrpEC_gazebo hrpIo_gazebo hrpsysBaseStub)
set_target_properties(hrpEC_gazebo PROPERTIES PREFIX "")
set_target_properties(hrpEC_gazebo PROPERTIES LIBRARY_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR}/lib)
set_target_properties(hrpEC_gazebo PROPERTIES OUTPUT_NAME hrpEC)
set_target_properties(hrpEC_gazebo PROPERTIES COMPILE_DEFINITIONS "OPENRTM_VERSION110")


install(TARGETS hrpIo_gazebo
  LIBRARY DESTINATION lib CONFIGURATIONS Release Debug RelWithDebInfo
)
install(TARGETS RobotHardwareComp_gazebo RobotHardware_gazebo hrpEC_gazebo
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/lib
)

=== debian/changelog ===
ros-indigo-hrpsys-gazebo-general (0.1.12-0trusty) trusty; urgency=high

  * [hrpsys_gazebo_general][iob/CMakeLists.txt] fix: remove build type specification from install
  * [hrpsys_gazebo_general] Pass CONF_FILE option to hrpsys_ros_bridge.launch
  * Contributors: Yuki Furuta, Iori Kumagai

 -- Yohei Kakiuchi <youhei@jsk.t.u-tokyo.ac.jp>  Tue, 10 Jan 2017 15:00:00 -0000

ros-indigo-hrpsys-gazebo-general (0.1.11-0trusty) trusty; urgency=high

  * [hrpsys_gazebo_general/CMakeLists.txt, hrpsys_gazebo_general/cmake/compile_robot_model_for_gazebo.cmake] install whole robot_models directory.
  * Modified package.xml to fix dependency
  * Merge pull request #224 <https://github.com/start-jsk/rtmros_gazebo/issues/224> from mmurooka/add-LIP-plugin
    [hrpsys_gazebo_general, hrpsys_gazebo_msgs] Add plugin for Linear Inverted Pendulum
  * [hrpsys_gazebo_general/src/LIPPlugin.cpp] add LIPPlugin, which controls Linear Inverted Pendulum.
  * [hrpsys_gazebo_general/package.xml] set gazebo_model_path in package.xml
  * Contributors: Masaki Murooka, Shunichi Nozawa, Iori Yanokura

 -- Yohei Kakiuchi <youhei@jsk.t.u-tokyo.ac.jp>  Mon, 29 Aug 2016 15:00:00 -0000

ros-indigo-hrpsys-gazebo-general (0.1.10-0trusty) trusty; urgency=high

  * [CMakeLists.txt] hotfix for compiling iob, https://github.com/fkanehiro/hrpsys-base/pull/803
  * [hrpsys_gazebo_general] Supress message from SetVelPlugin.cpp
  * [hrpsys_gazebo_general/src/IOBPlugin.cpp] add message when timeout loose synchronization
  * [hrpsys_gazebo_general] add USE_ROBOT_POSE_EKF and USE_FOOTCOORDS  argument to select how to compute odometry
  * [hrpsys_gazebo_general] Use $PROJECT_DIR to specify path to model file
  * [hrpsys_gazebo_general/src/SetVelPlugin.cpp] set pose in gazebo loop by SetVelPlugin
  * [hrpsys_gazebo_general/launch/samplerobot_hrpsys_bringup.launch] add kinematics mode option to launch file of sample robot in rtmros_gazebo
  * [CMakeLists.txt, Makefile] Remove rosbuild related files
  * [hrpsys_gazebo_general/scripts/gazebo_robot_kinematics_mode.py] do not disable gravity in kinematics mode
  * [hrpsys_gazebo_general/src/IOBPlugin.cpp] add publish stepping
  * [hrpsys_gazebo_general/src/IOBPlugin.cpp] add averaging joint effort
  * [hrpsys_gazebo_general/cmake/compile_robot_model_for_gazebo.cmake] add auto generation for default robot config file for gazebo
  * [hrpsys_gazebo_general/iob/iob.cpp] add loose_synchronize mode to IOBPlugin
  * [hrpsys_gazebo_general/iob/iob.cpp] fix for setting gain on velocity feedback mode
  * [hrpsys_gazebo_general/iob/iob.cpp] average filtering force sensor
  * [hrpsys_gazebo_general] Add BASE_LINK argument
  * [hrpsys_gazebo_general/launch/robot_hrpsys_bringup.launch,hrpsys_gazebo_general/scripts/gazebo_robot_kinematics_mode.py] add launch file option and script for gazebo kinematics mode
  * [hrpsys_gazebo_general/launch/gazebo_kinect.launch, hrpsys_gazebo_general/launch/gazebo_sensor.launch, hrpsys_gazebo_general/worlds/empty_slow.world] use slow update world file for sensor simulation
  * [hrpsys_gazebo_general/launch/robot_hrpsys_bringup.launch] add hrpsys_py argument
  * [hrpsys_gazebo_general] Add kinect sensor
    * add PubTfPlugin
    * fix indent of SetVelPlugin
    * add kinect launch file
  * Contributors: Masaki Murooka, Ryohei Ueda, Yohei Kakiuchi, Eisoku Kuroiwa, Shintaro Noda

 -- Yohei Kakiuchi <youhei@jsk.t.u-tokyo.ac.jp>  Wed, 23 Mar 2016 15:00:00 -0000

ros-indigo-hrpsys-gazebo-general (0.1.9-0trusty) trusty; urgency=high

  * Replace shared_dynamic_cast to dynamic_pointer_cast because shared_dynamic_cast is deprecated from boost 1.53
  * [hrpsys_gazebo_general] Use find_package macro to look up collada_jsk_patch package
  * [hrpsys_gazebo_general] Fix typo
  * [hrpsys_gazebo_general] Fix path for catkin build
  * add use_joint_effort for using effort on velocity feedback mode
  * Contributors: Ryohei Ueda, YoheiKakiuchi, Iori Kumagai

 -- Yohei Kakiuchi <youhei@jsk.t.u-tokyo.ac.jp>  Wed, 10 Jun 2015 15:00:00 -0000

ros-indigo-hrpsys-gazebo-general (0.1.8-0trusty) trusty; urgency=high

  * fix CHANGELOG order, https://github.com/ros/rosdistro/pull/6794

 -- Yohei Kakiuchi <youhei@jsk.t.u-tokyo.ac.jp>  Thu, 08 Jan 2015 15:00:00 -0000

ros-indigo-hrpsys-gazebo-general (0.1.7-0trusty) trusty; urgency=high

  * add pthread for link only for raling 64bit
  * Contributors: Kei Okada

 -- Yohei Kakiuchi <youhei@jsk.t.u-tokyo.ac.jp>  Thu, 08 Jan 2015 15:00:00 -0000

ros-indigo-hrpsys-gazebo-general (0.1.6-0trusty) trusty; urgency=high

  * update CHANGELOG.rst
  * add dl to target_link_libraries
  * add SPAWN_MODEL and fix for PAUSE
  * change model name when spawning robot model
  * update setup.sh
  * fix using SPAWN_MODEL argument
  * udpate PubQueue.h for matching gazebo_ros_pkgs
  * Contributors: Kei Okada, YoheiKakiuchi

 -- Yohei Kakiuchi <youhei@jsk.t.u-tokyo.ac.jp>  Wed, 07 Jan 2015 15:00:00 -0000

ros-indigo-hrpsys-gazebo-general (0.1.4-0trusty) trusty; urgency=high

  * install compile-robot-model-for-gazebo.cmake
  * deletece unnecessary file. added xacro file

 -- Yohei Kakiuchi <youhei@jsk.t.u-tokyo.ac.jp>  Wed, 22 Oct 2014 15:00:00 -0000

ros-indigo-hrpsys-gazebo-general (0.1.3-0trusty) trusty; urgency=high

  * set CMAKE_BUILD_TYPE to install, also support RelWithDebInfo for deb release
  * install files
  * add compile_robot_model_for_gazebo.cmake and generate model and launch file for samplerobot simulation.
  * Contributors: Kei Okada, Masaki Murooka

 -- Yohei Kakiuchi <youhei@jsk.t.u-tokyo.ac.jp>  Sat, 11 Oct 2014 15:00:00 -0000

ros-indigo-hrpsys-gazebo-general (0.1.2-0trusty) trusty; urgency=high

  * add gazebo_ros, gazebo_msgs, and gazebo_plugins to dependency of hrpsys_gazebo_general, eusgaebo.
  * Merge pull request #111 from k-okada/hrpEC_with_hrpIo_gazebo
    compile hrpEC liked with hrpIo_gazebo
  * add COMPILE_DEFINITIONS for hrpEC
  * Contributors: Kei Okada, Yohei Kakiuchi, Masaki Murooka



=== debian/control ===
Source: ros-indigo-hrpsys-gazebo-general
Section: misc
Priority: extra
Maintainer: Yohei Kakiuchi <youhei@jsk.t.u-tokyo.ac.jp>
Build-Depends: debhelper (>= 9.0.0), ros-indigo-catkin, ros-indigo-collada-urdf-jsk-patch, ros-indigo-gazebo-ros, ros-indigo-hrpsys-gazebo-msgs, ros-indigo-hrpsys-ros-bridge
Homepage: http://ros.org/wiki/hrpsys_gazebo_general
Standards-Version: 3.9.2

Package: ros-indigo-hrpsys-gazebo-general
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-indigo-collada-urdf-jsk-patch, ros-indigo-gazebo-ros, ros-indigo-hrpsys-gazebo-msgs, ros-indigo-hrpsys-ros-bridge, ros-indigo-turtlebot-description, ros-indigo-xacro
Description: hrpsys_gazebo_general

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v --buildsystem=cmake
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh  $@

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-hrpsys-gazebo-general//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
